org.apache.solr.core

## Class CloseHook

- java.lang.Object
- - org.apache.solr.core.CloseHook

-     public abstract class CloseHook
      extends Object

  Used to request notification when the core is closed.

  Call `SolrCore.addCloseHook(org.apache.solr.core.CloseHook)` during the `SolrCoreAware.inform(SolrCore)` method to add a close hook to your object.

  The close hook can be useful for releasing objects related to the request handler (for instance, if you have a JDBC DataSource or something like that)

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CloseHook()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract void` | `postClose(SolrCore core)` Method called when the given SolrCore object has been shut down and update handlers and searchers are closed Use this method for post-close clean up operations e.g.
    `abstract void` | `preClose(SolrCore core)` Method called when the given SolrCore object is closing / shutting down but before the update handler and searcher(s) are actually closed Important: Keep the method implementation as short as possible.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CloseHook

          public CloseHook()

  - ### Method Detail

    - #### preClose

          public abstract void preClose(SolrCore core)

      Method called when the given SolrCore object is closing / shutting down but before the update handler and searcher(s) are actually closed
      Important: Keep the method implementation as short as possible. If it were to use any heavy i/o , network connections - it might be a better idea to launch in a separate Thread so as to not to block the process of shutting down a given SolrCore instance.
      Parameters:
        `core` - SolrCore object that is shutting down / closing

    - #### postClose

          public abstract void postClose(SolrCore core)

      Method called when the given SolrCore object has been shut down and update handlers and searchers are closed
      Use this method for post-close clean up operations e.g. deleting the index from disk.
      The core's passed to the method is already closed and therefore, its update handler or searcher should *NOT* be used Important: Keep the method implementation as short as possible. If it were to use any heavy i/o , network connections - it might be a better idea to launch in a separate Thread so as to not to block the process of shutting down a given SolrCore instance.

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.